JSON for Modern C++ 3.7.3

accept
accept
accept
allocator_type
array
array_t
at
at
at
at
at
at
back
back
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
begin
begin
binary
binary
binary
binary
binary_t
boolean_t
cbegin
cend
clear
const_iterator
const_pointer
const_reference
const_reverse_iterator
contains
contains
count
crbegin
crend
detail::external_constructor
diff
difference_type
dump
emplace
emplace_back
empty
end
end
erase
erase
erase
erase
error_handler_t
exception
find
find
flatten
from_bson
from_bson
from_bson
from_cbor
from_cbor
from_cbor
from_msgpack
from_msgpack
from_msgpack
from_ubjson
from_ubjson
from_ubjson
front
front
get
get
get
get
get
get
get_allocator
get_binary
get_binary
get_ptr
get_ptr
get_ref
get_ref
get_to
get_to
initializer_list_t
input_format_t
insert
insert
insert
insert
insert
insert
insert_iterator
invalid_iterator
is_array
is_binary
is_boolean
is_discarded
is_null
is_number
is_number_float
is_number_integer
is_number_unsigned
is_object
is_primitive
is_string
is_structured
items
items
iterator
iterator_wrapper
iterator_wrapper
json_pointer
json_sax_t
json_serializer
max_size
merge_patch
meta
number_float_t
number_integer_t
number_unsigned_t
object
object_comparator_t
object_t
operator value_t
operator ValueType
operator!=
operator!=
operator!=
operator+=
operator+=
operator+=
operator+=
operator<
operator<
operator<
operator<<
operator<<
operator<=
operator<=
operator<=
operator=
operator==
operator==
operator==
operator>
operator>
operator>
operator>=
operator>=
operator>=
operator>>
operator>>
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
other_error
out_of_range
parse
parse
parse
parse_error
parse_event_t
parser_callback_t
patch
pointer
push_back
push_back
push_back
push_back
rbegin
rbegin
reference
rend
rend
reverse_iterator
sax_parse
sax_parse
sax_parse
size
size_type
string_t
swap
swap
swap
swap
swap
swap
to_bson
to_bson
to_bson
to_cbor
to_cbor
to_cbor
to_msgpack
to_msgpack
to_msgpack
to_ubjson
to_ubjson
to_ubjson
type
type_error
type_name
unflatten
update
update
value
value
value
value
value_t
value_type
~basic_json
| ## ◆ unflatten()
basic_json nlohmann::basic_json::unflatten | ( |  | ) | const
| inline
  The function restores the arbitrary nesting of a JSON value that has been flattened before using the flatten() function. The JSON value must meet certain constraints: The value must be an object. The keys must be JSON pointers (see RFC 6901) The mapped values must be primitive JSON types. Returns the original JSON from a flattened version Note Empty objects and arrays are flattened by flatten() to `null` values and can not unflattened to their original type. Apart from this example, for a JSON value `j`, the following is always true: `j == j.flatten().unflatten()`. Complexity Linear in the size the JSON value. Exceptions
  type_error.314 | if value is not an object
  type_error.315 | if object values are not primitive
  Example The following code shows how a flattened JSON object is unflattened into the original nested JSON object. 1 #include <iostream> 2 #include <iomanip> 3 #include <nlohmann/json.hpp> 4 5 using json = nlohmann::json; 6 7 int main() 8 { 9 // create JSON value 10 json j_flattened = 11 { 12 {"/answer/everything", 42}, 13 {"/happy", true}, 14 {"/list/0", 1}, 15 {"/list/1", 0}, 16 {"/list/2", 2}, 17 {"/name", "Niels"}, 18 {"/nothing", nullptr}, 19 {"/object/currency", "USD"}, 20 {"/object/value", 42.99}, 21 {"/pi", 3.141} 22 }; 23 24 // call unflatten() 25 std::cout << std::setw(4) << j_flattened.unflatten() << '\n'; 26 } Output (play with this example online):
      {
          "answer": {
              "everything": 42
          },
          "happy": true,
          "list": [
              1,
              0,
              2
          ],
          "name": "Niels",
          "nothing": null,
          "object": {
              "currency": "USD",
              "value": 42.99
          },
          "pi": 3.141
      }
  The example code above can be translated with
      g++ -std=c++11 -Isingle_include doc/examples/unflatten.cpp -o unflatten
See also flatten() for the reverse function Since version 2.0.0 Definition at line 23826 of file json.hpp.

nlohmann::json
basic_json<> json
default JSON class
Definition: json.hpp:2774